#line 1 "C:/Users/Ng Yong Han/Documents/pic_projects2012/matrixclock/matrixclock.c"
#line 25 "C:/Users/Ng Yong Han/Documents/pic_projects2012/matrixclock/matrixclock.c"
void init();


void HT1632_Init();
void HT1632_Command(unsigned int command);
void HT1632_SendData(unsigned char address, unsigned char inputData);
void HT1632_WriteNum(unsigned char col, unsigned char num);
void frameBufferClear();
void HT1632_Clear();
void HT1632_DrawFrameBuffer();


unsigned char BCD2UpperInt(unsigned char bcd);
unsigned char BCD2LowerInt(unsigned char bcd);
unsigned char byte2BCD(unsigned char inputByte);
unsigned char BCD2Int(unsigned char bcd);
void write_ds1307(unsigned short address,unsigned short w_data);
unsigned short read_ds1307(unsigned short address);


void readTemperatureDS18B20();


unsigned char minute = 0;
unsigned char hour = 0;
unsigned char minute_temp = 0;
unsigned char hour_temp = 0;
unsigned char temp_timer = 0;
unsigned char time[4] = { 0 };
unsigned char tempByte = 0;
unsigned char tempTens = 0;
unsigned char tempOnes = 0;

unsigned char frameBuffer[32] = { 0 };
unsigned char scratchPadTemp[2] = { 0 };


unsigned char font5x7[] = {

0x3E, 0x45, 0x49, 0x51, 0x3E,
0x00, 0x40, 0x7F, 0x42, 0x00,
0x46, 0x49, 0x51, 0x61, 0x42,
0x31, 0x4B, 0x45, 0x41, 0x21,
0x10, 0x7F, 0x12, 0x14, 0x18,
0x39, 0x45, 0x45, 0x45, 0x27,
0x30, 0x49, 0x49, 0x4A, 0x3C,
0x03, 0x05, 0x09, 0x71, 0x01,
0x36, 0x49, 0x49, 0x49, 0x36,
0x1E, 0x29, 0x49, 0x49, 0x06,
0x00, 0x00, 0x36, 0x36, 0x00,
0x22, 0x41, 0x41, 0x41, 0x3E,
0x00, 0x07, 0x05, 0x07, 0x00

};

void main() {

unsigned char isTimeSet = 0;

init();

HT1632_Init();

delay_ms(250);

isTimeSet = read_ds1307(0x08);
isTimeSet = read_ds1307(0x08);

if (isTimeSet == 1) {

 hour = read_ds1307(2);
 minute = read_ds1307(1);
 HT1632_Command( 0b000010000 );

}
else {

 write_ds1307(0, 0b10000000);
 write_ds1307(1, byte2BCD(00));
 write_ds1307(2, byte2BCD(00));
 write_ds1307(0, 0b00000000);
 HT1632_Command( 0b000010010 );

}

frameBufferClear();
HT1632_Clear();

readTemperatureDS18B20();

delay_ms(2000);

while(1)
{
frameBufferClear();

hour = read_ds1307(2);
minute = read_ds1307(1);

if(PORTB.RB0 == 0)
{
 delay_ms(5);
 hour_temp = BCD2Int(hour);
 hour_temp++;
 if(hour_temp > 23)
 hour_temp = 0;
 write_ds1307(2, byte2BCD(hour_temp));
 write_ds1307(0x08, 0x01);
 HT1632_Command( 0b000010000 );
}

if(PORTB.RB1 == 0)
{
 delay_ms(5);
 minute_temp = BCD2Int(minute);
 minute_temp++;
 if(minute_temp > 59)
 minute_temp = 0;
 write_ds1307(1, byte2BCD(minute_temp));
 write_ds1307(0x08, 0x01);
 HT1632_Command( 0b000010000 );
}


if(PORTB.RB2 == 0)
{
 delay_ms(5);
 frameBufferClear();
 while(temp_timer < 5)
 {
 delay_ms(1000);
 temp_timer++;
 HT1632_WriteNum(27-4, tempTens);
 HT1632_WriteNum(21-4, tempOnes);
 HT1632_WriteNum(15-4,  12 );
 HT1632_WriteNum(9-4,  11 );
 HT1632_DrawFrameBuffer();
 }
 temp_timer = 0;
 frameBufferClear();
}

time[0] = BCD2UpperInt(hour);
time[1] = BCD2LowerInt(hour);
time[2] = BCD2UpperInt(minute);
time[3] = BCD2LowerInt(minute);

readTemperatureDS18B20();

HT1632_WriteNum(27-2, time[0]);

HT1632_WriteNum(21-2, time[1]);

HT1632_WriteNum(15-2, 10);

HT1632_WriteNum(9-1, time[2]);

HT1632_WriteNum(3-1, time[3]);

HT1632_DrawFrameBuffer();

delay_ms(250);

}

}

void init()
{
ADCON0.ADON = 0;
ADCON1.PCFG3 = 0;
ADCON1.PCFG2 = 1;
ADCON1.PCFG1 = 1;
ADCON1.PCFG0 = 0;

TRISC = 0x00;
TRISD = 0x00;
TRISB.RB0 = 1;
TRISB.RB1 = 1;
TRISB.RB2 = 1;

OPTION_REG.INTEDG = 0;
INTCON.INTE = 0;
INTCON.PEIE = 0;
INTCON.GIE = 0;
INTCON.INTF = 0;


I2C1_Init(100000);
I2C1_Start();

}

void HT1632_Command(unsigned int command)
{

unsigned char i;
unsigned int j, k, regAMSB;

 PORTD.RD0  = 1;
delay_us(1);

j = command << 4;

regAMSB = 0b1000000000000000 | j;

 PORTD.RD0  = 0;
delay_us(1);

for(i=0; i<16; i++)
{
  PORTD.RD2  = (regAMSB >> 15) & 0x0001;
 regAMSB = regAMSB << 1;
  PORTD.RD1  = 0;
 delay_us(1);
  PORTD.RD1  = 1;
 delay_us(1);
}

 PORTD.RD0  = 1;
delay_us(1);

}

void HT1632_SendData(unsigned char address, unsigned char inputData)
{

unsigned char i;
unsigned int j, l, regAMSB;

 PORTD.RD0  = 1;
delay_us(1);

j = (address & 0x7F) << 6;
l = (inputData & 0x000f) << 2;
regAMSB = 0b1010000000000000 | j | l;

regAMSB = regAMSB >> 2;

 PORTD.RD0  = 0;
delay_us(1);

for(i=0; i<14; i++)
{
  PORTD.RD2  = (regAMSB >> 13) & 0x0001;
 regAMSB = regAMSB << 1;
  PORTD.RD1  = 0;
 delay_us(1);
  PORTD.RD1  = 1;
 delay_us(1);
}

 PORTD.RD0  = 1;
delay_us(1);

}

void HT1632_WriteNum(unsigned char col, unsigned char num)
{

 unsigned char i;

 for(i = 0; i < 5; i++)
 frameBuffer[col+i] |= font5x7[num*5 + i];

}

void HT1632_DrawFrameBuffer()
{

unsigned char i, j;

for(i = 0; i < 32; i++)
 HT1632_SendData(2*i, (frameBuffer[i] >> 4) & 0x0f);

for(i = 0; i < 32; i++)
 HT1632_SendData(2*i+1, frameBuffer[i] & 0x0f);

}

void HT1632_Init()
{

HT1632_Command( 0b000000010 );
HT1632_Command( 0b000000110 );
HT1632_Command( 0b000110000 );
HT1632_Command( 0b001000000 );
HT1632_Command( 0b101011110 );
HT1632_Command( 0b000010000 );

}

void frameBufferClear()
{
unsigned char i = 0;

for(i = 0; i < 32; i++)
 frameBuffer[i] = 0x00;

}

void HT1632_Clear()
{

unsigned char i = 0;

for(i = 0; i < 64; i++)
 HT1632_SendData(i, 0x00);

}

void readTemperatureDS18B20()
{

Ow_Reset(&PORTA, 0);
Ow_Write(&PORTA, 0, 0xCC);
Ow_Write(&PORTA, 0, 0x44);

delay_us(120);

Ow_Reset(&PORTA, 0);
Ow_Write(&PORTA, 0, 0xCC);
Ow_Write(&PORTA, 0, 0xBE);

scratchPadTemp[0] = Ow_Read(&PORTA, 0);
scratchPadTemp[1] = Ow_Read(&PORTA, 0);

scratchpadTemp[0] = 0b11110000 & scratchpadTemp[0];
scratchpadTemp[1] = 0b00000111 & scratchpadTemp[1];

tempByte = (scratchpadTemp[1] << 4) | (scratchpadTemp[0] >> 4);

tempTens = tempByte / 10;
tempOnes = tempByte % 10;

}


unsigned char BCD2UpperInt(unsigned char bcd) {
 return (bcd & 0xf0) >> 4;
}

unsigned char BCD2LowerInt(unsigned char bcd) {
 return ((bcd & 0x0F));
}

unsigned char byte2BCD(unsigned char inputByte) {
 unsigned char tens, ones, BCDresult;

 tens = inputByte / 10;
 ones = inputByte % 10;

 BCDresult = ((tens & 0x0f) << 4) | (ones & 0x0f);

 return BCDresult;
}

unsigned char BCD2Int(unsigned char bcd) {
 return ((BCD2UpperInt(bcd) * 10) + BCD2LowerInt(bcd));
}

void write_ds1307(unsigned short address,unsigned short w_data)
{
I2C1_Start();

I2C1_Wr(0xD0);
I2C1_Wr(address);
I2C1_Wr(w_data);
I2C1_Stop();
}

unsigned short read_ds1307(unsigned short address)
{

unsigned short readData;
I2C1_Start();
I2C1_Wr(0xd0);
I2C1_Wr(address);
I2C1_Repeated_Start();
I2C1_Wr(0xd1);
readData=I2C1_Rd(0);
I2C1_Stop();
return readData;
}
